Attribute VB_Name = "modBrowse"
' Catalyst Internet Mail Control 4.0
' Copyright 2002, Catalyst Development Corporation
' All rights reserved
'
' This product is licensed to you pursuant to the terms of the
' Catalyst license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Type BROWSEINFO
     hwndOwner As Long
     pIDLRoot As Long
     pszDisplayName As Long
     lpszTitle As Long
     ulFlags As Long
     lpfnCallback As Long
     lParam As Long
     iImage As Long
End Type

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const MAX_PATH = 260

Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long

Public Function BrowseForFolder(ByVal hWnd As Long, Optional ByVal varPrompt As Variant) As String
    Dim pidList As Long
    Dim lResult As Long
    Dim strPrompt As String
    Dim strPath As String
    Dim infoBrowse As BROWSEINFO

    If IsMissing(varPrompt) Then
        strPrompt = ""
    Else
        strPrompt = CStr(varPrompt)
    End If

    infoBrowse.hwndOwner = hWnd
    infoBrowse.lpszTitle = lstrcat(strPrompt, "")
    infoBrowse.ulFlags = BIF_RETURNONLYFSDIRS

    pidList = SHBrowseForFolder(infoBrowse)
    If pidList Then
        strPath = String(MAX_PATH, 0)
        lResult = SHGetPathFromIDList(pidList, strPath)
        CoTaskMemFree pidList
        strPath = Left(strPath, InStr(strPath, Chr(0)) - 1)
    End If

     BrowseForFolder = strPath
End Function

