Option Strict Off
Option Explicit On
Module modBrowse
	' Catalyst Internet Mail Control 4.0
	' Copyright 2002, Catalyst Development Corporation
	' All rights reserved
	'
	' This product is licensed to you pursuant to the terms of the
	' Catalyst license agreement included with the original software,
	' and is protected by copyright law and international treaties.
	' Unauthorized reproduction or distribution may result in severe
	' criminal penalties.
	'
	
	Private Structure BROWSEINFO
		Dim hwndOwner As Integer
		Dim pIDLRoot As Integer
        Dim pszDisplayName As String
        Dim lpszTitle As String
		Dim ulFlags As Integer
		Dim lpfnCallback As Integer
		Dim lParam As Integer
		Dim iImage As Integer
	End Structure
	
	Private Const BIF_RETURNONLYFSDIRS As Short = 1
	Private Const MAX_PATH As Short = 260
	
	Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal hMem As Integer)
    Private Declare Function SHBrowseForFolder Lib "shell32" (ByRef lpbi As BROWSEINFO) As Integer
    Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Integer, ByVal lpBuffer As String) As Integer
	
    Public Function BrowseForFolder(ByVal hWnd As Integer, Optional ByVal strPrompt As String = "") As String
        Dim pidList As Integer
        Dim lResult As Integer
        Dim strPath As String
        Dim infoBrowse As BROWSEINFO

        infoBrowse.hwndOwner = hWnd
        infoBrowse.lpszTitle = strPrompt
        infoBrowse.ulFlags = BIF_RETURNONLYFSDIRS

        pidList = SHBrowseForFolder(infoBrowse)
        If pidList Then
            strPath = New String(Chr(0), MAX_PATH)
            lResult = SHGetPathFromIDList(pidList, strPath)
            CoTaskMemFree(pidList)
            strPath = Left(strPath, InStr(strPath, Chr(0)) - 1)
        End If

        BrowseForFolder = strPath
    End Function
End Module